<?php

if ( isset($_POST['token']) ) 
{
  $token = $_POST['token'];
  $device_id = $_POST['device_id'];
  $json_str = '{"token":"' . $token . '", "routeridx":' . $device_id . '}';
  file_put_contents('../bin/ddnsto-config.json', $json_str);
//  system('killall ddnstomonitor >/dev/null && sleep 1');
  system('killall ddnsto >/dev/null && sleep 3');
//  system('/apps/ddnsto/bin/ddnsto -d >/dev/null && sleep 2');
  echo "<script>location.href='index.php';</script>";
//system('start-stop-daemon -K -R 5 -q -p "/var/run/aria2c.pid"');
}

?>

<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>DDNSTO 配置</title>
    <meta name="renderer" content="webkit">
    <meta name="viewport" content="width=device-width, initial-scale=1.0,maximum-scale=1.0, user-scalable=no">
    <meta http-equiv="Cache-Control" content="no-siteapp">
    <meta name="theme-color" content="#ffffff">
    <meta name="x5-page-mode" content="app">
    <meta name="apple-mobile-web-app-title" content="DDNSTO">
    <meta name="apple-mobile-web-app-capable" content="yes">
    <link rel="shortcut icon" href="static/favicon.ico" type="image/x-icon">
    <script src="static/jquery-2.2.3.min.js" type="text/javascript"></script>

</head>

<body>
    
<div style="margin:0 auto; width:600px;">
<form id="ddnsto_form" action="index.php" method="post">
    <div id="main">
        <label>
            <div class="key">Token: (<a href="https://www.ddnsto.com/app/" target="_blank">官网获取</a> token)</div>
            <div class="value">
                <input type="text" name="token" id="device_token" value=""/>
            </div>
        </label>
        <label>
            <div class="key">设备编号：(默认为0，有多个重复id则1-100)</div>
            <div class="value">
                <input name="device_id" type="number" max="100" min="0" id="device_idx" value="0"/>
            </div>
        </label>
                    <span id="spn_message">进程状态检测中...</span>
<p align="center">
            <button class="sumbit" data-key="sumbit">
                确   定
            </button>
</p>            
            </div>
    </div>
</form>
</body>
<style>
    body {
        margin: 0;
        padding: 5px;
    }

    div#main {
        /* width: 700px;
        height: 300px; */
        margin: 0 auto;
        width: 100%;
    }

    form {
        width: 100%;
        height: 100%;
        display: block;
    }

    label,
    li {
        width: 100%;
        height: 100px;
        list-style: none;
        display: block;
        /* display: flex;
        flex-wrap: wrap;
        align-items: center; */
    }

    .key {
        flex: 0 0 100%;
        width: 100%;
        font-size: 20px;
        color: #333333;
        height: 40px;
        line-height: 40px;
        overflow: hidden;
        white-space: nowrap;
        text-overflow: ellipsis;
    }

    .value {
        flex: 0 0 100%;
        width: 100%;
        font-size: 20px;
        color: #333333;

    }

    input {
        padding: 0;
        width: 100%;
        height: 100%;
        border: 1px solid #a3a3a3;
        border-radius: 3px;
        padding: 5px 10px;
        height: 40px;
        line-height: 40px;
        font-size: 20px;
        box-sizing: border-box;
        -webkit-box-sizing: border-box;
        -moz-box-sizing: border-box;

    }

    input:hover,
    input:focus {
        outline: none;
    }

    button.sumbit {
        border: none;
        background: #1991ff;
        height: 40px;
        width: 25%;
        color: #fff;
        font-size: 18px;
        cursor: grab;
    }

    button.sumbit:hover,
    button.sumbit:focus {
        outline: none;
        opacity: 0.8;
    }

</style>
<script>

<?php
    echo 'var ddnsto_config=';
    echo file_get_contents("../bin/ddnsto-config.json");
    echo ';';
?>

    var check_ddnsto_pid = 0;

    var timeoutfn = function() { 
      if (check_ddnsto_pid > 9) {
        $("#spn_message").html("进程未运行");
        return;
      }
      check_ddnsto_pid++;

      $.ajax({
        type: 'GET',
        dataType: 'text',
        url: 'ddnsto-pid.php',
        timeout: 5000,
        success: function(dataText, textStatus ){
          var data = jQuery.parseJSON(dataText);
          if(data["pid"]) {
            $("#spn_message").html("进程运行中，PID：" + data["pid"] + " 设备信息：" + data["ver"]);
          } else {
            $("#spn_message").html("进程检测中，第 " + check_ddnsto_pid + " 次");
            setTimeout(timeoutfn, 3000);
          }
        },
        fail: function(xhr, textStatus, errorThrown){
          console.log('check pid request failed');
        }
      });

    };

    $(document).ready(function() {
      $('#ddnsto_form').submit(function(e) {
        var deviceToken = $("#device_token").val();
        var deviceId = $('#device_idx').val();
        if (isNaN(deviceId)) {
            $("#spn_message").html("设备编号不能为 非法数值");
            check_ddnsto_pid = 10;
            return false;
        }
        if (deviceId < 0 || deviceId > 100) {
            $("#spn_message").html("设备编号超出 0 - 100 范围");
            check_ddnsto_pid = 10;
            return false;
        }
        if (deviceToken == "" || deviceToken.length == 0 || deviceToken == null) {
            $("#spn_message").html("token 不能为空");
            check_ddnsto_pid = 10;
            return false;
        }
        check_ddnsto_pid = 10;
        $("#spn_message").html("提交中...");
        return true;
      });

      $("#device_token").val(ddnsto_config["token"]);
      $('#device_idx').val(ddnsto_config["routeridx"]);

      timeoutfn();

    });

</script>
</div>
</html>
